# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `ode` Chapter.
"""

# NAG Copyright 2017-2019.

from ..base import utils

bvp_shoot_genpar_intern_aux = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, param[*].
)
bvp_shoot_genpar_intern_bcaux = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Output, g0[*].
    utils._EngineFloat64ArrayType.c_type, # Output, g1[*].
    utils._EngineFloat64ArrayType.c_type, # Input, param[*].
)
bvp_shoot_genpar_intern_raaux = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Output, x0.
    utils._BYREF_FLOAT64, # Output, x1.
    utils._BYREF_FLOAT64, # Output, r.
    utils._EngineFloat64ArrayType.c_type, # Input, param[*].
)
bvp_shoot_genpar_intern_prsol = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Input, param[n1].
    utils._BYREF_FLOAT64, # Input, res.
    utils._BYREF_INT, # Input, n1.
    utils._EngineFloat64ArrayType.c_type, # Input, err[n1].
)
bvp_shoot_genpar_intern = utils._EngineState._get_symbol('d02agf')
bvp_shoot_genpar_intern.restype = None
bvp_shoot_genpar_intern.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, h.
    utils._EngineFloat64ArrayType.c_type, # Input, e[n].
    utils._EngineFloat64ArrayType.c_type, # Input, parerr[n1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, param[n1].
    utils._EngineFloat64ArrayType.c_type, # Output, c[m1, n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, n1.
    utils._BYREF_INT, # Input, m1.
    bvp_shoot_genpar_intern_aux,
    bvp_shoot_genpar_intern_bcaux,
    bvp_shoot_genpar_intern_raaux,
    bvp_shoot_genpar_intern_prsol,
    utils._EngineFloat64ArrayType.c_type, # Workspace, mat[n1, n1].
    utils._EngineFloat64ArrayType.c_type, # Input, copy[1, 1].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wspace[n, 9].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wspac1[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wspac2[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkm_val_simple_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
)
ivp_rkm_val_simple = utils._EngineState._get_symbol('d02bgf')
ivp_rkm_val_simple.restype = None
ivp_rkm_val_simple.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, xend.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[n].
    utils._BYREF_FLOAT64, # Input/Output, tol.
    utils._BYREF_FLOAT64, # Input, hmax.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, val.
    ivp_rkm_val_simple_fcn,
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[n, 10].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkm_zero_simple_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
)
ivp_rkm_zero_simple_g = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)
ivp_rkm_zero_simple = utils._EngineState._get_symbol('d02bhf')
ivp_rkm_zero_simple.restype = None
ivp_rkm_zero_simple.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, xend.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[n].
    utils._BYREF_FLOAT64, # Input/Output, tol.
    utils._BYREF_INT, # Input, irelab.
    utils._BYREF_FLOAT64, # Input, hmax.
    ivp_rkm_zero_simple_fcn,
    ivp_rkm_zero_simple_g,
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[n, 7].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rk_zero_simple_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
)
ivp_rk_zero_simple_output = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input/Output, xsol.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)
ivp_rk_zero_simple_g = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)
ivp_rk_zero_simple = utils._EngineState._get_symbol('d02bjf')
ivp_rk_zero_simple.restype = None
ivp_rk_zero_simple.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, xend.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[n].
    ivp_rk_zero_simple_fcn,
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_STRING, # Input, relabs(len=1).
    ivp_rk_zero_simple_output,
    ivp_rk_zero_simple_g,
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[20*n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of relabs.
)

ivp_rk_zero_simple_dummy_g = utils._EngineState._get_symbol('d02bjw')
ivp_rk_zero_simple_dummy_g.restype = utils._EngineFloat64ScalarType.c_type
ivp_rk_zero_simple_dummy_g.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)

ivp_rk_zero_simple_dummy_output = utils._EngineState._get_symbol('d02bjx')
ivp_rk_zero_simple_dummy_output.restype = None
ivp_rk_zero_simple_dummy_output.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, xsol.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)

ivp_adams_zero_simple_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
)
ivp_adams_zero_simple_output = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input/Output, xsol.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)
ivp_adams_zero_simple_g = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)
ivp_adams_zero_simple = utils._EngineState._get_symbol('d02cjf')
ivp_adams_zero_simple.restype = None
ivp_adams_zero_simple.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, xend.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[n].
    ivp_adams_zero_simple_fcn,
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_STRING, # Input, relabs(len=1).
    ivp_adams_zero_simple_output,
    ivp_adams_zero_simple_g,
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[28+21*n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of relabs.
)

ivp_adams_zero_simple_dummy_g = utils._EngineState._get_symbol('d02cjw')
ivp_adams_zero_simple_dummy_g.restype = utils._EngineFloat64ScalarType.c_type
ivp_adams_zero_simple_dummy_g.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)

ivp_adams_zero_simple_dummy_output = utils._EngineState._get_symbol('d02cjx')
ivp_adams_zero_simple_dummy_output.restype = None
ivp_adams_zero_simple_dummy_output.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, xsol.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)

ivp_bdf_zero_simple_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
)
ivp_bdf_zero_simple_pederv = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, pw[*].
)
ivp_bdf_zero_simple_output = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input/Output, xsol.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)
ivp_bdf_zero_simple_g = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)
ivp_bdf_zero_simple = utils._EngineState._get_symbol('d02ejf')
ivp_bdf_zero_simple.restype = None
ivp_bdf_zero_simple.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, xend.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[n].
    ivp_bdf_zero_simple_fcn,
    ivp_bdf_zero_simple_pederv,
    utils._BYREF_FLOAT64, # Input/Output, tol.
    utils._BYREF_STRING, # Input, relabs(len=1).
    ivp_bdf_zero_simple_output,
    ivp_bdf_zero_simple_g,
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[iw].
    utils._BYREF_INT, # Input, iw.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of relabs.
)

ivp_bdf_zero_simple_dummy_g = utils._EngineState._get_symbol('d02ejw')
ivp_bdf_zero_simple_dummy_g.restype = utils._EngineFloat64ScalarType.c_type
ivp_bdf_zero_simple_dummy_g.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)

ivp_bdf_zero_simple_dummy_output = utils._EngineState._get_symbol('d02ejx')
ivp_bdf_zero_simple_dummy_output.restype = None
ivp_bdf_zero_simple_dummy_output.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, xsol.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
)

ivp_bdf_zero_simple_dummy_pederv = utils._EngineState._get_symbol('d02ejy')
ivp_bdf_zero_simple_dummy_pederv.restype = None
ivp_bdf_zero_simple_dummy_pederv.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, pw[*].
)

bvp_fd_nonlin_fixedbc_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
)
bvp_fd_nonlin_fixedbc = utils._EngineState._get_symbol('d02gaf')
bvp_fd_nonlin_fixedbc.restype = None
bvp_fd_nonlin_fixedbc.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, u[n, 2].
    utils._EngineFloat64ArrayType.c_type, # Input, v[n, 2].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_FLOAT64, # Input, tol.
    bvp_fd_nonlin_fixedbc_fcn,
    utils._BYREF_INT, # Input, mnp.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[mnp].
    utils._EngineFloat64ArrayType.c_type, # Output, y[n, mnp].
    utils._BYREF_INT, # Input/Output, np.
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Workspace, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_fd_nonlin_gen_dummy_jacobf = utils._EngineState._get_symbol('d02gaw')
bvp_fd_nonlin_gen_dummy_jacobf.restype = None
bvp_fd_nonlin_gen_dummy_jacobf.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[n].
    utils._BYREF_INT, # Input, n.
)

bvp_fd_nonlin_gen_dummy_jacobg = utils._EngineState._get_symbol('d02gax')
bvp_fd_nonlin_gen_dummy_jacobg.restype = None
bvp_fd_nonlin_gen_dummy_jacobg.argtypes = (
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, ya[n].
    utils._EngineFloat64ArrayType.c_type, # Input, yb[n].
    utils._EngineFloat64ArrayType.c_type, # Output, bcep[n].
    utils._BYREF_INT, # Input, n.
)

bvp_fd_nonlin_gen_dummy_jaceps = utils._EngineState._get_symbol('d02gay')
bvp_fd_nonlin_gen_dummy_jaceps.restype = None
bvp_fd_nonlin_gen_dummy_jaceps.argtypes = (
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, ya[n].
    utils._EngineFloat64ArrayType.c_type, # Input, yb[n].
    utils._EngineFloat64ArrayType.c_type, # Output, aj[n, n].
    utils._EngineFloat64ArrayType.c_type, # Output, bj[n, n].
    utils._BYREF_INT, # Input, n.
)

bvp_fd_nonlin_gen_dummy_jacgep = utils._EngineState._get_symbol('d02gaz')
bvp_fd_nonlin_gen_dummy_jacgep.restype = None
bvp_fd_nonlin_gen_dummy_jacgep.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[n, n].
    utils._BYREF_INT, # Input, n.
)

bvp_fd_lin_gen_fcnf = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
)
bvp_fd_lin_gen_fcng = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Output, g[*].
)
bvp_fd_lin_gen = utils._EngineState._get_symbol('d02gbf')
bvp_fd_lin_gen.restype = None
bvp_fd_lin_gen.argtypes = (
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, tol.
    bvp_fd_lin_gen_fcnf,
    bvp_fd_lin_gen_fcng,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[n, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, d[n, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, gam[n].
    utils._BYREF_INT, # Input, mnp.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[mnp].
    utils._EngineFloat64ArrayType.c_type, # Output, y[n, mnp].
    utils._BYREF_INT, # Input/Output, np.
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Workspace, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_shoot_bval_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
)
bvp_shoot_bval = utils._EngineState._get_symbol('d02haf')
bvp_shoot_bval.restype = None
bvp_shoot_bval.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input/Output, u[n, 2].
    utils._EngineFloat64ArrayType.c_type, # Input, v[n, 2].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_FLOAT64, # Input, tol.
    bvp_shoot_bval_fcn,
    utils._EngineFloat64ArrayType.c_type, # Output, soln[n, m1].
    utils._BYREF_INT, # Input, m1.
    utils._EngineFloat64ArrayType.c_type, # Output, w[n, sdw].
    utils._BYREF_INT, # Input, sdw.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_shoot_genpar_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[*].
    utils._EngineFloat64ArrayType.c_type, # Output, f[*].
    utils._EngineFloat64ArrayType.c_type, # Input, p[*].
)
bvp_shoot_genpar_bc = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Output, g1[*].
    utils._EngineFloat64ArrayType.c_type, # Output, g2[*].
    utils._EngineFloat64ArrayType.c_type, # Input, p[*].
)
bvp_shoot_genpar_range = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Output, a.
    utils._BYREF_FLOAT64, # Output, b.
    utils._EngineFloat64ArrayType.c_type, # Input, p[*].
)
bvp_shoot_genpar = utils._EngineState._get_symbol('d02hbf')
bvp_shoot_genpar.restype = None
bvp_shoot_genpar.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[n1].
    utils._BYREF_INT, # Input, n1.
    utils._EngineFloat64ArrayType.c_type, # Input, pe[n1].
    utils._EngineFloat64ArrayType.c_type, # Input, e[n].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, soln[n, m1].
    utils._BYREF_INT, # Input, m1.
    bvp_shoot_genpar_fcn,
    bvp_shoot_genpar_bc,
    bvp_shoot_genpar_range,
    utils._EngineFloat64ArrayType.c_type, # Output, w[n, sdw].
    utils._BYREF_INT, # Input, sdw.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_shoot_genpar_algeq_dummy_prsol = utils._EngineState._get_symbol('d02hbw')
bvp_shoot_genpar_algeq_dummy_prsol.restype = None
bvp_shoot_genpar_algeq_dummy_prsol.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, z.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._BYREF_INT, # Input, n.
)

bvp_shoot_genpar_algeq_sample_monit = utils._EngineState._get_symbol('d02hbx')
bvp_shoot_genpar_algeq_sample_monit.restype = None
bvp_shoot_genpar_algeq_sample_monit.argtypes = (
    utils._BYREF_INT, # Input, istate.
    utils._BYREF_INT, # Input, iflag.
    utils._BYREF_INT, # Input, ifail1.
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, f[m].
    utils._BYREF_FLOAT64, # Input, pnorm.
    utils._BYREF_FLOAT64, # Input, pnorm1.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, d[m].
)

bvp_shoot_genpar_algeq_dummy_constr = utils._EngineState._get_symbol('d02hby')
bvp_shoot_genpar_algeq_dummy_constr.restype = utils._EngineLogicalScalarType.c_type
bvp_shoot_genpar_algeq_dummy_constr.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
)

bvp_shoot_genpar_algeq_dummy_eqn = utils._EngineState._get_symbol('d02hbz')
bvp_shoot_genpar_algeq_dummy_eqn.restype = None
bvp_shoot_genpar_algeq_dummy_eqn.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Output, e[q].
    utils._BYREF_INT, # Input, q.
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
)

bvp_coll_nth_cf = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_INT, # Input, j.
    utils._BYREF_FLOAT64, # Input, x.
)
bvp_coll_nth_bc = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, i.
    utils._BYREF_INT, # Output, j.
    utils._BYREF_FLOAT64, # Output, rhs.
)
bvp_coll_nth = utils._EngineState._get_symbol('d02jaf')
bvp_coll_nth.restype = None
bvp_coll_nth.argtypes = (
    utils._BYREF_INT, # Input, n.
    bvp_coll_nth_cf,
    bvp_coll_nth_bc,
    utils._BYREF_FLOAT64, # Input, x0.
    utils._BYREF_FLOAT64, # Input, x1.
    utils._BYREF_INT, # Input, k1.
    utils._BYREF_INT, # Input, kp.
    utils._EngineFloat64ArrayType.c_type, # Output, c[k1].
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Workspace, iw[k1].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_coll_sys_cf = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_INT, # Input, i.
    utils._BYREF_INT, # Input, j.
    utils._BYREF_FLOAT64, # Input, x.
)
bvp_coll_sys_bc = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, i.
    utils._BYREF_INT, # Output, j.
    utils._BYREF_FLOAT64, # Output, rhs.
)
bvp_coll_sys = utils._EngineState._get_symbol('d02jbf')
bvp_coll_sys.restype = None
bvp_coll_sys.argtypes = (
    utils._BYREF_INT, # Input, n.
    bvp_coll_sys_cf,
    bvp_coll_sys_bc,
    utils._BYREF_FLOAT64, # Input, x0.
    utils._BYREF_FLOAT64, # Input, x1.
    utils._BYREF_INT, # Input, k1.
    utils._BYREF_INT, # Input, kp.
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, n].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Workspace, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._BYREF_INT, # Input/Output, ifail.
)

sl2_reg_finite_coeffn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Output, p.
    utils._BYREF_FLOAT64, # Output, q.
    utils._BYREF_FLOAT64, # Output, dqdl.
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._BYREF_INT, # Input, jint.
)
sl2_reg_finite_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nit.
    utils._BYREF_INT, # Input, iflag.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._EngineFloat64ArrayType.c_type, # Input, finfo[15].
)
sl2_reg_finite = utils._EngineState._get_symbol('d02kaf')
sl2_reg_finite.restype = None
sl2_reg_finite.argtypes = (
    utils._BYREF_FLOAT64, # Input, xl.
    utils._BYREF_FLOAT64, # Input, xr.
    sl2_reg_finite_coeffn,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bcond[3, 2].
    utils._BYREF_INT, # Input, k.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_FLOAT64, # Input/Output, elam.
    utils._BYREF_FLOAT64, # Input/Output, delam.
    sl2_reg_finite_monit,
    utils._BYREF_INT, # Input/Output, ifail.
)

sl2_reg_finite_dummy_monit = utils._EngineState._get_symbol('d02kay')
sl2_reg_finite_dummy_monit.restype = None
sl2_reg_finite_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, nit.
    utils._BYREF_INT, # Input, iflag.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._EngineFloat64ArrayType.c_type, # Input, finfo[15].
)

sl2_breaks_vals_coeffn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Output, p.
    utils._BYREF_FLOAT64, # Output, q.
    utils._BYREF_FLOAT64, # Output, dqdl.
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._BYREF_INT, # Input, jint.
)
sl2_breaks_vals_bdyval = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, xl.
    utils._BYREF_FLOAT64, # Input, xr.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._EngineFloat64ArrayType.c_type, # Output, yl[3].
    utils._EngineFloat64ArrayType.c_type, # Output, yr[3].
)
sl2_breaks_vals_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nit.
    utils._BYREF_INT, # Input, iflag.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._EngineFloat64ArrayType.c_type, # Input, finfo[15].
)
sl2_breaks_vals = utils._EngineState._get_symbol('d02kdf')
sl2_breaks_vals.restype = None
sl2_breaks_vals.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, xpoint[m].
    utils._BYREF_INT, # Input, m.
    sl2_breaks_vals_coeffn,
    sl2_breaks_vals_bdyval,
    utils._BYREF_INT, # Input, k.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_FLOAT64, # Input/Output, elam.
    utils._BYREF_FLOAT64, # Input/Output, delam.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, hmax[2, m].
    utils._BYREF_INT, # Input/Output, maxit.
    utils._BYREF_INT, # Input, maxfun.
    sl2_breaks_vals_monit,
    utils._BYREF_INT, # Input/Output, ifail.
)

sl2_breaks_funs_coeffn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Output, p.
    utils._BYREF_FLOAT64, # Output, q.
    utils._BYREF_FLOAT64, # Output, dqdl.
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._BYREF_INT, # Input, jint.
)
sl2_breaks_funs_bdyval = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, xl.
    utils._BYREF_FLOAT64, # Input, xr.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._EngineFloat64ArrayType.c_type, # Output, yl[3].
    utils._EngineFloat64ArrayType.c_type, # Output, yr[3].
)
sl2_breaks_funs_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nit.
    utils._BYREF_INT, # Input, iflag.
    utils._BYREF_FLOAT64, # Input, elam.
    utils._EngineFloat64ArrayType.c_type, # Input, finfo[15].
)
sl2_breaks_funs_report = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, v[3].
    utils._BYREF_INT, # Input, jint.
)
sl2_breaks_funs = utils._EngineState._get_symbol('d02kef')
sl2_breaks_funs.restype = None
sl2_breaks_funs.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, xpoint[m].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input/Output, match.
    sl2_breaks_funs_coeffn,
    sl2_breaks_funs_bdyval,
    utils._BYREF_INT, # Input, k.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_FLOAT64, # Input/Output, elam.
    utils._BYREF_FLOAT64, # Input/Output, delam.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, hmax[2, m].
    utils._BYREF_INT, # Input/Output, maxit.
    utils._BYREF_INT, # Input, maxfun.
    sl2_breaks_funs_monit,
    sl2_breaks_funs_report,
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_2nd_rkn_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, f[neq].
)
ivp_2nd_rkn = utils._EngineState._get_symbol('d02laf')
ivp_2nd_rkn.restype = None
ivp_2nd_rkn.argtypes = (
    ivp_2nd_rkn_fcn,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input, tend.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, yp[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ydp[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_2nd_rkn_setup = utils._EngineState._get_symbol('d02lxf')
ivp_2nd_rkn_setup.restype = None
ivp_2nd_rkn_setup.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._EngineFloat64ArrayType.c_type, # Input, thres[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, thresp[neq].
    utils._BYREF_INT, # Input, maxstp.
    utils._BYREF_LOGICAL, # Input/Output, start.
    utils._BYREF_LOGICAL, # Input, onestp.
    utils._BYREF_LOGICAL, # Input, high.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_2nd_rkn_diag = utils._EngineState._get_symbol('d02lyf')
ivp_2nd_rkn_diag.restype = None
ivp_2nd_rkn_diag.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Output, hnext.
    utils._BYREF_FLOAT64, # Output, hused.
    utils._BYREF_FLOAT64, # Output, hstart.
    utils._BYREF_INT, # Output, nsucc.
    utils._BYREF_INT, # Output, nfail.
    utils._BYREF_INT, # Output, natt.
    utils._EngineFloat64ArrayType.c_type, # Output, thres[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, thresp[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_2nd_rkn_interp = utils._EngineState._get_symbol('d02lzf')
ivp_2nd_rkn_interp.restype = None
ivp_2nd_rkn_interp.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, yp[neq].
    utils._BYREF_INT, # Input, nwant.
    utils._BYREF_FLOAT64, # Input, twant.
    utils._EngineFloat64ArrayType.c_type, # Output, ywant[nwant].
    utils._EngineFloat64ArrayType.c_type, # Output, ypwant[nwant].
    utils._EngineFloat64ArrayType.c_type, # Input, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

dae_dassl_cont = utils._EngineState._get_symbol('d02mcf')
dae_dassl_cont.restype = None
dae_dassl_cont.argtypes = (
    utils._EngineIntArrayType.c_type, # Input/Output, icom[15].
)

ivp_stiff_dassl = utils._EngineState._get_symbol('d02mvf')
ivp_stiff_dassl.restype = None
ivp_stiff_dassl.argtypes = (
    utils._BYREF_INT, # Input, neqmax.
    utils._BYREF_INT, # Input, sdysav.
    utils._BYREF_INT, # Input, maxord.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, con[3].
    utils._BYREF_FLOAT64, # Input, tcrit.
    utils._BYREF_FLOAT64, # Input, hmin.
    utils._BYREF_FLOAT64, # Input, hmax.
    utils._BYREF_FLOAT64, # Input, h0.
    utils._BYREF_INT, # Input, maxstp.
    utils._BYREF_INT, # Input, mxhnil.
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neqmax].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
)

dae_dassl_setup = utils._EngineState._get_symbol('d02mwf')
dae_dassl_setup.restype = None
dae_dassl_setup.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, maxord.
    utils._BYREF_STRING, # Input, jceval(len=1).
    utils._BYREF_FLOAT64, # Input, hmax.
    utils._BYREF_FLOAT64, # Input, h0.
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Output, icom[licom].
    utils._BYREF_INT, # Input, licom.
    utils._EngineFloat64ArrayType.c_type, # Output, com[lcom].
    utils._BYREF_INT, # Input, lcom.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of jceval.
)

ivp_stiff_interp = utils._EngineState._get_symbol('d02mzf')
ivp_stiff_interp.restype = None
ivp_stiff_interp.argtypes = (
    utils._BYREF_FLOAT64, # Input, tsol.
    utils._EngineFloat64ArrayType.c_type, # Output, sol[m].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_INT, # Input, neq.
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    utils._EngineFloat64ArrayType.c_type, # Input, rwork[50+4*neq].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_exp_fulljac_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, f[neq].
    utils._BYREF_INT, # Input/Output, ires.
)
ivp_stiff_exp_fulljac_jac = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[neq, neq].
)
ivp_stiff_exp_fulljac_monitr = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_FLOAT64, # Input, hlast.
    utils._BYREF_FLOAT64, # Input/Output, hnext.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, *].
    utils._EngineFloat64ArrayType.c_type, # Input, r[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, acor[neq, 2].
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Output, inln.
    utils._BYREF_FLOAT64, # Input/Output, hmin.
    utils._BYREF_FLOAT64, # Input/Output, hmax.
    utils._BYREF_INT, # Input, nqu.
)
ivp_stiff_exp_fulljac = utils._EngineState._get_symbol('d02nbf')
ivp_stiff_exp_fulljac.restype = None
ivp_stiff_exp_fulljac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input, atol[*].
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Input/Output, inform[23].
    ivp_stiff_exp_fulljac_fcn,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    ivp_stiff_exp_fulljac_jac,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wkjac[nwkjac].
    utils._BYREF_INT, # Input, nwkjac.
    ivp_stiff_exp_fulljac_monitr,
    utils._BYREF_INT, # Input, itask.
    utils._BYREF_INT, # Input, itrace.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_exp_fulljac_dummy_monit = utils._EngineState._get_symbol('d02nby')
ivp_stiff_exp_fulljac_dummy_monit.restype = None
ivp_stiff_exp_fulljac_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_FLOAT64, # Input, hlast.
    utils._BYREF_FLOAT64, # Input/Output, hnext.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, *].
    utils._EngineFloat64ArrayType.c_type, # Input, r[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, acor[neq, 2].
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Output, inln.
    utils._BYREF_FLOAT64, # Input/Output, hmin.
    utils._BYREF_FLOAT64, # Input/Output, hmax.
    utils._BYREF_INT, # Input, nqu.
)

ivp_stiff_exp_fulljac_dummy_jac = utils._EngineState._get_symbol('d02nbz')
ivp_stiff_exp_fulljac_dummy_jac.restype = None
ivp_stiff_exp_fulljac_dummy_jac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[neq, neq].
)

ivp_stiff_exp_bandjac_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, f[neq].
    utils._BYREF_INT, # Input/Output, ires.
)
ivp_stiff_exp_bandjac_jac = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._BYREF_INT, # Input, ml.
    utils._BYREF_INT, # Input, mu.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[ml+mu+1, neq].
)
ivp_stiff_exp_bandjac_monitr = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_FLOAT64, # Input, hlast.
    utils._BYREF_FLOAT64, # Input/Output, hnext.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, *].
    utils._EngineFloat64ArrayType.c_type, # Input, r[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, acor[neq, 2].
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Output, inln.
    utils._BYREF_FLOAT64, # Input/Output, hmin.
    utils._BYREF_FLOAT64, # Input/Output, hmax.
    utils._BYREF_INT, # Input, nqu.
)
ivp_stiff_exp_bandjac = utils._EngineState._get_symbol('d02ncf')
ivp_stiff_exp_bandjac.restype = None
ivp_stiff_exp_bandjac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input, atol[*].
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Input/Output, inform[23].
    ivp_stiff_exp_bandjac_fcn,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    ivp_stiff_exp_bandjac_jac,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wkjac[nwkjac].
    utils._BYREF_INT, # Input, nwkjac.
    utils._EngineIntArrayType.c_type, # Input/Output, jacpvt[njcpvt].
    utils._BYREF_INT, # Input, njcpvt.
    ivp_stiff_exp_bandjac_monitr,
    utils._BYREF_INT, # Input, itask.
    utils._BYREF_INT, # Input, itrace.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_exp_bandjac_dummy_jac = utils._EngineState._get_symbol('d02ncz')
ivp_stiff_exp_bandjac_dummy_jac.restype = None
ivp_stiff_exp_bandjac_dummy_jac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._BYREF_INT, # Input, ml.
    utils._BYREF_INT, # Input, mu.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[ml+mu+1, neq].
)

ivp_stiff_exp_sparjac_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, f[neq].
    utils._BYREF_INT, # Input/Output, ires.
)
ivp_stiff_exp_sparjac_jac = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._BYREF_INT, # Input, j.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, pdj[neq].
)
ivp_stiff_exp_sparjac_monitr = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_FLOAT64, # Input, hlast.
    utils._BYREF_FLOAT64, # Input/Output, hnext.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, *].
    utils._EngineFloat64ArrayType.c_type, # Input, r[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, acor[neq, 2].
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Output, inln.
    utils._BYREF_FLOAT64, # Input/Output, hmin.
    utils._BYREF_FLOAT64, # Input/Output, hmax.
    utils._BYREF_INT, # Input, nqu.
)
ivp_stiff_exp_sparjac = utils._EngineState._get_symbol('d02ndf')
ivp_stiff_exp_sparjac.restype = None
ivp_stiff_exp_sparjac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input, atol[*].
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Input/Output, inform[23].
    ivp_stiff_exp_sparjac_fcn,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    ivp_stiff_exp_sparjac_jac,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wkjac[nwkjac].
    utils._BYREF_INT, # Input, nwkjac.
    utils._EngineIntArrayType.c_type, # Input/Output, jacpvt[njcpvt].
    utils._BYREF_INT, # Input, njcpvt.
    ivp_stiff_exp_sparjac_monitr,
    utils._BYREF_INT, # Input, itask.
    utils._BYREF_INT, # Input, itrace.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_exp_sparjac_dummy_jac = utils._EngineState._get_symbol('d02ndz')
ivp_stiff_exp_sparjac_dummy_jac.restype = None
ivp_stiff_exp_sparjac_dummy_jac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._BYREF_INT, # Input, j.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, pdj[neq].
)

dae_dassl_gen_res = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, r[neq].
    utils._BYREF_INT, # Input/Output, ires.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
dae_dassl_gen_jac = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, pd[*].
    utils._BYREF_FLOAT64, # Input, cj.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
dae_dassl_gen = utils._EngineState._get_symbol('d02nef')
dae_dassl_gen.restype = None
dae_dassl_gen.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, atol[*].
    utils._BYREF_INT, # Input/Output, itask.
    dae_dassl_gen_res,
    dae_dassl_gen_jac,
    utils._EngineIntArrayType.c_type, # Input/Output, icom[50+neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, com[lcom].
    utils._BYREF_INT, # Input, lcom.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

dae_dassl_gen_dummy_jac = utils._EngineState._get_symbol('d02nez')
dae_dassl_gen_dummy_jac.restype = None
dae_dassl_gen_dummy_jac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, pd[*].
    utils._BYREF_FLOAT64, # Input, cj.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

ivp_stiff_imp_fulljac_resid = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, r[neq].
    utils._BYREF_INT, # Input/Output, ires.
)
ivp_stiff_imp_fulljac_jac = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[neq, neq].
)
ivp_stiff_imp_fulljac_monitr = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_FLOAT64, # Input, hlast.
    utils._BYREF_FLOAT64, # Input/Output, hnext.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, *].
    utils._EngineFloat64ArrayType.c_type, # Input, r[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, acor[neq, 2].
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Output, inln.
    utils._BYREF_FLOAT64, # Input/Output, hmin.
    utils._BYREF_FLOAT64, # Input/Output, hmax.
    utils._BYREF_INT, # Input, nqu.
)
ivp_stiff_imp_fulljac = utils._EngineState._get_symbol('d02ngf')
ivp_stiff_imp_fulljac.restype = None
ivp_stiff_imp_fulljac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input/Output, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input, atol[*].
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Input/Output, inform[23].
    ivp_stiff_imp_fulljac_resid,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    ivp_stiff_imp_fulljac_jac,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wkjac[nwkjac].
    utils._BYREF_INT, # Input, nwkjac.
    ivp_stiff_imp_fulljac_monitr,
    utils._EngineLogicalArrayType.c_type, # Input/Output, lderiv[2].
    utils._BYREF_INT, # Input, itask.
    utils._BYREF_INT, # Input, itrace.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_imp_fulljac_dummy_jac = utils._EngineState._get_symbol('d02ngz')
ivp_stiff_imp_fulljac_dummy_jac.restype = None
ivp_stiff_imp_fulljac_dummy_jac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[neq, neq].
)

ivp_stiff_imp_bandjac_resid = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, r[neq].
    utils._BYREF_INT, # Input/Output, ires.
)
ivp_stiff_imp_bandjac_jac = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._BYREF_INT, # Input, ml.
    utils._BYREF_INT, # Input, mu.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[ml+mu+1, neq].
)
ivp_stiff_imp_bandjac_monitr = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_FLOAT64, # Input, hlast.
    utils._BYREF_FLOAT64, # Input/Output, hnext.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, *].
    utils._EngineFloat64ArrayType.c_type, # Input, r[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, acor[neq, 2].
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Output, inln.
    utils._BYREF_FLOAT64, # Input/Output, hmin.
    utils._BYREF_FLOAT64, # Input/Output, hmax.
    utils._BYREF_INT, # Input, nqu.
)
ivp_stiff_imp_bandjac = utils._EngineState._get_symbol('d02nhf')
ivp_stiff_imp_bandjac.restype = None
ivp_stiff_imp_bandjac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input/Output, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input, atol[*].
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Input/Output, inform[23].
    ivp_stiff_imp_bandjac_resid,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    ivp_stiff_imp_bandjac_jac,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wkjac[nwkjac].
    utils._BYREF_INT, # Input, nwkjac.
    utils._EngineIntArrayType.c_type, # Input/Output, jacpvt[njcpvt].
    utils._BYREF_INT, # Input, njcpvt.
    ivp_stiff_imp_bandjac_monitr,
    utils._EngineLogicalArrayType.c_type, # Input/Output, lderiv[2].
    utils._BYREF_INT, # Input, itask.
    utils._BYREF_INT, # Input, itrace.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_imp_bandjac_dummy_jac = utils._EngineState._get_symbol('d02nhz')
ivp_stiff_imp_bandjac_dummy_jac.restype = None
ivp_stiff_imp_bandjac_dummy_jac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._BYREF_INT, # Input, ml.
    utils._BYREF_INT, # Input, mu.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[ml+mu+1, neq].
)

ivp_stiff_imp_sparjac_resid = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, r[neq].
    utils._BYREF_INT, # Input/Output, ires.
)
ivp_stiff_imp_sparjac_jac = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._BYREF_INT, # Input, j.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, pdj[neq].
)
ivp_stiff_imp_sparjac_monitr = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_FLOAT64, # Input, hlast.
    utils._BYREF_FLOAT64, # Input/Output, hnext.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, *].
    utils._EngineFloat64ArrayType.c_type, # Input, r[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, acor[neq, 2].
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Output, inln.
    utils._BYREF_FLOAT64, # Input/Output, hmin.
    utils._BYREF_FLOAT64, # Input/Output, hmax.
    utils._BYREF_INT, # Input, nqu.
)
ivp_stiff_imp_sparjac = utils._EngineState._get_symbol('d02njf')
ivp_stiff_imp_sparjac.restype = None
ivp_stiff_imp_sparjac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input/Output, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input, atol[*].
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Input/Output, inform[23].
    ivp_stiff_imp_sparjac_resid,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    ivp_stiff_imp_sparjac_jac,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wkjac[nwkjac].
    utils._BYREF_INT, # Input, nwkjac.
    utils._EngineIntArrayType.c_type, # Input/Output, jacpvt[njcpvt].
    utils._BYREF_INT, # Input, njcpvt.
    ivp_stiff_imp_sparjac_monitr,
    utils._EngineLogicalArrayType.c_type, # Input/Output, lderiv[2].
    utils._BYREF_INT, # Input, itask.
    utils._BYREF_INT, # Input, itrace.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_imp_sparjac_dummy_jac = utils._EngineState._get_symbol('d02njz')
ivp_stiff_imp_sparjac_dummy_jac.restype = None
ivp_stiff_imp_sparjac_dummy_jac.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, t.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, ydot[neq].
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, d.
    utils._BYREF_INT, # Input, j.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, pdj[neq].
)

ivp_stiff_exp_revcom = utils._EngineState._get_symbol('d02nmf')
ivp_stiff_exp_revcom.restype = None
ivp_stiff_exp_revcom.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input, atol[*].
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Input/Output, inform[23].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wkjac[nwkjac].
    utils._BYREF_INT, # Input, nwkjac.
    utils._EngineIntArrayType.c_type, # Input/Output, jacpvt[njcpvt].
    utils._BYREF_INT, # Input, njcpvt.
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Input/Output, inln.
    utils._BYREF_INT, # Input/Output, ires.
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, itask.
    utils._BYREF_INT, # Input, itrace.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_imp_revcom = utils._EngineState._get_symbol('d02nnf')
ivp_stiff_imp_revcom.restype = None
ivp_stiff_imp_revcom.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._BYREF_FLOAT64, # Input/Output, tout.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ydot[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neq].
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[*].
    utils._EngineFloat64ArrayType.c_type, # Input, atol[*].
    utils._BYREF_INT, # Input, itol.
    utils._EngineIntArrayType.c_type, # Input/Output, inform[23].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, sdysav.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wkjac[nwkjac].
    utils._BYREF_INT, # Input, nwkjac.
    utils._EngineIntArrayType.c_type, # Input/Output, jacpvt[njcpvt].
    utils._BYREF_INT, # Input, njcpvt.
    utils._BYREF_INT, # Input/Output, imon.
    utils._BYREF_INT, # Input/Output, inln.
    utils._BYREF_INT, # Input/Output, ires.
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lderiv[2].
    utils._BYREF_INT, # Input, itask.
    utils._BYREF_INT, # Input, itrace.
    utils._BYREF_INT, # Input/Output, ifail.
)

dae_dassl_linalg = utils._EngineState._get_symbol('d02npf')
dae_dassl_linalg.restype = None
dae_dassl_linalg.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, ml.
    utils._BYREF_INT, # Input, mu.
    utils._EngineIntArrayType.c_type, # Input/Output, icom[licom].
    utils._BYREF_INT, # Input, licom.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_sparjac_enq = utils._EngineState._get_symbol('d02nrf')
ivp_stiff_sparjac_enq.restype = None
ivp_stiff_sparjac_enq.argtypes = (
    utils._BYREF_INT, # Output, j.
    utils._BYREF_INT, # Output, iplace.
    utils._EngineIntArrayType.c_type, # Input, inform[23].
)

ivp_stiff_fulljac_setup = utils._EngineState._get_symbol('d02nsf')
ivp_stiff_fulljac_setup.restype = None
ivp_stiff_fulljac_setup.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, neqmax.
    utils._BYREF_STRING, # Input, jceval(len=1).
    utils._BYREF_INT, # Input, nwkjac.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neqmax].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of jceval.
)

ivp_stiff_bandjac_setup = utils._EngineState._get_symbol('d02ntf')
ivp_stiff_bandjac_setup.restype = None
ivp_stiff_bandjac_setup.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, neqmax.
    utils._BYREF_STRING, # Input, jceval(len=1).
    utils._BYREF_INT, # Input, ml.
    utils._BYREF_INT, # Input, mu.
    utils._BYREF_INT, # Input, nwkjac.
    utils._BYREF_INT, # Input, njcpvt.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neqmax].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of jceval.
)

ivp_stiff_sparjac_setup = utils._EngineState._get_symbol('d02nuf')
ivp_stiff_sparjac_setup.restype = None
ivp_stiff_sparjac_setup.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, neqmax.
    utils._BYREF_STRING, # Input, jceval(len=1).
    utils._BYREF_INT, # Input, nwkjac.
    utils._EngineIntArrayType.c_type, # Input, ia[nia].
    utils._BYREF_INT, # Input, nia.
    utils._EngineIntArrayType.c_type, # Input, ja[nja].
    utils._BYREF_INT, # Input, nja.
    utils._EngineIntArrayType.c_type, # Output, jacpvt[njcpvt].
    utils._BYREF_INT, # Input, njcpvt.
    utils._BYREF_FLOAT64, # Input, sens.
    utils._BYREF_FLOAT64, # Input, u.
    utils._BYREF_FLOAT64, # Input, eta.
    utils._BYREF_LOGICAL, # Input, lblock.
    utils._BYREF_INT, # Input, isplit.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neqmax].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of jceval.
)

ivp_stiff_bdf = utils._EngineState._get_symbol('d02nvf')
ivp_stiff_bdf.restype = None
ivp_stiff_bdf.argtypes = (
    utils._BYREF_INT, # Input, neqmax.
    utils._BYREF_INT, # Input, sdysav.
    utils._BYREF_INT, # Input, maxord.
    utils._BYREF_STRING, # Input, method(len=1).
    utils._BYREF_LOGICAL, # Input, petzld.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, con[6].
    utils._BYREF_FLOAT64, # Input, tcrit.
    utils._BYREF_FLOAT64, # Input, hmin.
    utils._BYREF_FLOAT64, # Input, hmax.
    utils._BYREF_FLOAT64, # Input, h0.
    utils._BYREF_INT, # Input, maxstp.
    utils._BYREF_INT, # Input, mxhnil.
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neqmax].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
)

ivp_stiff_blend = utils._EngineState._get_symbol('d02nwf')
ivp_stiff_blend.restype = None
ivp_stiff_blend.argtypes = (
    utils._BYREF_INT, # Input, neqmax.
    utils._BYREF_INT, # Input, sdysav.
    utils._BYREF_INT, # Input, maxord.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, con[6].
    utils._BYREF_FLOAT64, # Input, tcrit.
    utils._BYREF_FLOAT64, # Input, hmin.
    utils._BYREF_FLOAT64, # Input, hmax.
    utils._BYREF_FLOAT64, # Input, h0.
    utils._BYREF_INT, # Input, maxstp.
    utils._BYREF_INT, # Input, mxhnil.
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neqmax].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
)

ivp_stiff_sparjac_diag = utils._EngineState._get_symbol('d02nxf')
ivp_stiff_sparjac_diag.restype = None
ivp_stiff_sparjac_diag.argtypes = (
    utils._BYREF_INT, # Input, icall.
    utils._BYREF_INT, # Output, liwreq.
    utils._BYREF_INT, # Output, liwusd.
    utils._BYREF_INT, # Output, lrwreq.
    utils._BYREF_INT, # Output, lrwusd.
    utils._BYREF_INT, # Output, nlu.
    utils._BYREF_INT, # Output, nnz.
    utils._BYREF_INT, # Output, ngp.
    utils._BYREF_INT, # Output, isplit.
    utils._BYREF_INT, # Output, igrow.
    utils._BYREF_LOGICAL, # Input, lblock.
    utils._BYREF_INT, # Output, nblock.
    utils._EngineIntArrayType.c_type, # Input, inform[23].
)

ivp_stiff_integ_diag = utils._EngineState._get_symbol('d02nyf')
ivp_stiff_integ_diag.restype = None
ivp_stiff_integ_diag.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, neqmax.
    utils._BYREF_FLOAT64, # Output, hu.
    utils._BYREF_FLOAT64, # Output, h.
    utils._BYREF_FLOAT64, # Output, tcur.
    utils._BYREF_FLOAT64, # Output, tolsf.
    utils._EngineFloat64ArrayType.c_type, # Input, rwork[50+4*neq].
    utils._BYREF_INT, # Output, nst.
    utils._BYREF_INT, # Output, nre.
    utils._BYREF_INT, # Output, nje.
    utils._BYREF_INT, # Output, nqu.
    utils._BYREF_INT, # Output, nq.
    utils._BYREF_INT, # Output, niter.
    utils._BYREF_INT, # Output, imxer.
    utils._EngineLogicalArrayType.c_type, # Output, algequ[neq].
    utils._EngineIntArrayType.c_type, # Input, inform[23].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_contin = utils._EngineState._get_symbol('d02nzf')
ivp_stiff_contin.restype = None
ivp_stiff_contin.argtypes = (
    utils._BYREF_INT, # Input, neqmax.
    utils._BYREF_FLOAT64, # Input, tcrit.
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, hmin.
    utils._BYREF_FLOAT64, # Input, hmax.
    utils._BYREF_INT, # Input, maxstp.
    utils._BYREF_INT, # Input, mxhnil.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[50+4*neqmax].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkts_range_f = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, yp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
ivp_rkts_range = utils._EngineState._get_symbol('d02pef')
ivp_rkts_range.restype = None
ivp_rkts_range.argtypes = (
    ivp_rkts_range_f,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, twant.
    utils._BYREF_FLOAT64, # Output, tgot.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ygot[n].
    utils._EngineFloat64ArrayType.c_type, # Output, ypgot[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ymax[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[32*n+350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkts_onestep_f = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, yp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
ivp_rkts_onestep = utils._EngineState._get_symbol('d02pff')
ivp_rkts_onestep.restype = None
ivp_rkts_onestep.argtypes = (
    ivp_rkts_onestep_f,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Output, tnow.
    utils._EngineFloat64ArrayType.c_type, # Output, ynow[n].
    utils._EngineFloat64ArrayType.c_type, # Output, ypnow[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[32*n+350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rk_step_revcomm = utils._EngineState._get_symbol('d02pgf')
ivp_rk_step_revcomm.restype = None
ivp_rk_step_revcomm.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Output, t.
    utils._EngineFloat64ArrayType.c_type, # Output, y[n].
    utils._EngineFloat64ArrayType.c_type, # Input, yp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[32*n+350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rk_interp_setup = utils._EngineState._get_symbol('d02phf')
ivp_rk_interp_setup.restype = None
ivp_rk_interp_setup.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nwant.
    utils._BYREF_FLOAT64, # Output, t.
    utils._EngineFloat64ArrayType.c_type, # Output, y[n].
    utils._EngineFloat64ArrayType.c_type, # Input, yp[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wcomm[lwcomm].
    utils._BYREF_INT, # Input, lwcomm.
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[32*n+350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rk_interp_eval = utils._EngineState._get_symbol('d02pjf')
ivp_rk_interp_eval.restype = None
ivp_rk_interp_eval.argtypes = (
    utils._BYREF_INT, # Input, icheck.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nwant.
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_INT, # Input, ideriv.
    utils._EngineFloat64ArrayType.c_type, # Output, sol[nwant].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wcomm[lwcomm].
    utils._BYREF_INT, # Input, lwcomm.
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[32*n+350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkts_setup = utils._EngineState._get_symbol('d02pqf')
ivp_rkts_setup.restype = None
ivp_rkts_setup.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, tstart.
    utils._BYREF_FLOAT64, # Input, tend.
    utils._EngineFloat64ArrayType.c_type, # Input, yinit[n].
    utils._BYREF_FLOAT64, # Input, tol.
    utils._EngineFloat64ArrayType.c_type, # Input, thresh[n].
    utils._BYREF_INT, # Input, method.
    utils._BYREF_FLOAT64, # Input, hstart.
    utils._EngineIntArrayType.c_type, # Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Output, rwsav[32*n+350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkts_reset_tend = utils._EngineState._get_symbol('d02prf')
ivp_rkts_reset_tend.restype = None
ivp_rkts_reset_tend.argtypes = (
    utils._BYREF_FLOAT64, # Input, tendnu.
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkts_interp_f = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, t.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, yp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
ivp_rkts_interp = utils._EngineState._get_symbol('d02psf')
ivp_rkts_interp.restype = None
ivp_rkts_interp.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, twant.
    utils._BYREF_INT, # Input, ideriv.
    utils._BYREF_INT, # Input, nwant.
    utils._EngineFloat64ArrayType.c_type, # Output, ywant[nwant].
    utils._EngineFloat64ArrayType.c_type, # Output, ypwant[nwant].
    ivp_rkts_interp_f,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wcomm[lwcomm].
    utils._BYREF_INT, # Input, lwcomm.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[32*n+350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkts_diag = utils._EngineState._get_symbol('d02ptf')
ivp_rkts_diag.restype = None
ivp_rkts_diag.argtypes = (
    utils._BYREF_INT, # Output, fevals.
    utils._BYREF_INT, # Output, stepcost.
    utils._BYREF_FLOAT64, # Output, waste.
    utils._BYREF_INT, # Output, stepsok.
    utils._BYREF_FLOAT64, # Output, hnext.
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input, rwsav[350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_rkts_errass = utils._EngineState._get_symbol('d02puf')
ivp_rkts_errass.restype = None
ivp_rkts_errass.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, rmserr[n].
    utils._BYREF_FLOAT64, # Output, errmax.
    utils._BYREF_FLOAT64, # Output, terrmx.
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[130].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[32*n+350].
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_adams_roots_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, neqf.
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neqf].
    utils._EngineFloat64ArrayType.c_type, # Output, f[neqf].
)
ivp_adams_roots_g = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_INT, # Input, neqf.
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neqf].
    utils._EngineFloat64ArrayType.c_type, # Input, yp[neqf].
    utils._BYREF_INT, # Input, k.
)
ivp_adams_roots = utils._EngineState._get_symbol('d02qff')
ivp_adams_roots.restype = None
ivp_adams_roots.argtypes = (
    ivp_adams_roots_fcn,
    utils._BYREF_INT, # Input, neqf.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neqf].
    utils._BYREF_FLOAT64, # Input, tout.
    ivp_adams_roots_g,
    utils._BYREF_INT, # Input, neqg.
    utils._BYREF_LOGICAL, # Output, root.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._EngineIntArrayType.c_type, # Input/Output, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_adams_roots_dummy_g = utils._EngineState._get_symbol('d02qfz')
ivp_adams_roots_dummy_g.restype = utils._EngineFloat64ScalarType.c_type
ivp_adams_roots_dummy_g.argtypes = (
    utils._BYREF_INT, # Input, neqf.
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neqf].
    utils._EngineFloat64ArrayType.c_type, # Input, yp[neqf].
    utils._BYREF_INT, # Input, k.
)

ivp_adams_roots_revcom = utils._EngineState._get_symbol('d02qgf')
ivp_adams_roots_revcom.restype = None
ivp_adams_roots_revcom.argtypes = (
    utils._BYREF_INT, # Input, neqf.
    utils._BYREF_FLOAT64, # Input/Output, t.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[neqf].
    utils._BYREF_FLOAT64, # Input, tout.
    utils._BYREF_INT, # Input, neqg.
    utils._BYREF_LOGICAL, # Output, root.
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_FLOAT64, # Output, trvcm.
    utils._BYREF_INT, # Output, yrvcm.
    utils._BYREF_INT, # Output, yprvcm.
    utils._BYREF_FLOAT64, # Input, grvcm.
    utils._BYREF_INT, # Input/Output, kgrvcm.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._EngineIntArrayType.c_type, # Input/Output, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_adams_setup = utils._EngineState._get_symbol('d02qwf')
ivp_adams_setup.restype = None
ivp_adams_setup.argtypes = (
    utils._BYREF_STRING, # Input/Output, statef(len=1).
    utils._BYREF_INT, # Input, neqf.
    utils._BYREF_LOGICAL, # Input, vectol.
    utils._EngineFloat64ArrayType.c_type, # Input, atol[latol].
    utils._BYREF_INT, # Input, latol.
    utils._EngineFloat64ArrayType.c_type, # Input, rtol[lrtol].
    utils._BYREF_INT, # Input, lrtol.
    utils._BYREF_LOGICAL, # Input, onestp.
    utils._BYREF_LOGICAL, # Input, crit.
    utils._BYREF_FLOAT64, # Input, tcrit.
    utils._BYREF_FLOAT64, # Input, hmax.
    utils._BYREF_INT, # Input, maxstp.
    utils._BYREF_INT, # Input, neqg.
    utils._BYREF_LOGICAL, # Input/Output, alterg.
    utils._BYREF_LOGICAL, # Input, sophst.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._EngineIntArrayType.c_type, # Input/Output, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of statef.
)

ivp_adams_diag = utils._EngineState._get_symbol('d02qxf')
ivp_adams_diag.restype = None
ivp_adams_diag.argtypes = (
    utils._BYREF_INT, # Input, neqf.
    utils._EngineFloat64ArrayType.c_type, # Output, yp[neqf].
    utils._BYREF_FLOAT64, # Output, tcurr.
    utils._BYREF_FLOAT64, # Output, hlast.
    utils._BYREF_FLOAT64, # Output, hnext.
    utils._BYREF_INT, # Output, odlast.
    utils._BYREF_INT, # Output, odnext.
    utils._BYREF_INT, # Output, nsucc.
    utils._BYREF_INT, # Output, nfail.
    utils._BYREF_FLOAT64, # Output, tolfac.
    utils._BYREF_INT, # Output, badcmp.
    utils._EngineFloat64ArrayType.c_type, # Input, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._EngineIntArrayType.c_type, # Input, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_adams_rootdiag = utils._EngineState._get_symbol('d02qyf')
ivp_adams_rootdiag.restype = None
ivp_adams_rootdiag.argtypes = (
    utils._BYREF_INT, # Input, neqg.
    utils._BYREF_INT, # Output, index.
    utils._BYREF_INT, # Output, itype.
    utils._EngineIntArrayType.c_type, # Output, events[neqg].
    utils._EngineFloat64ArrayType.c_type, # Output, resids[neqg].
    utils._EngineFloat64ArrayType.c_type, # Input, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._EngineIntArrayType.c_type, # Input, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_adams_interp = utils._EngineState._get_symbol('d02qzf')
ivp_adams_interp.restype = None
ivp_adams_interp.argtypes = (
    utils._BYREF_INT, # Input, neqf.
    utils._BYREF_FLOAT64, # Input, twant.
    utils._BYREF_INT, # Input, nwant.
    utils._EngineFloat64ArrayType.c_type, # Output, ywant[nwant].
    utils._EngineFloat64ArrayType.c_type, # Output, ypwant[nwant].
    utils._EngineFloat64ArrayType.c_type, # Input, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._EngineIntArrayType.c_type, # Input, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_fd_nonlin_gen_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[n].
    utils._BYREF_INT, # Input, n.
)
bvp_fd_nonlin_gen_g = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, ya[n].
    utils._EngineFloat64ArrayType.c_type, # Input, yb[n].
    utils._EngineFloat64ArrayType.c_type, # Output, bc[n].
    utils._BYREF_INT, # Input, n.
)
bvp_fd_nonlin_gen_jacobf = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[n, n].
    utils._BYREF_INT, # Input, n.
)
bvp_fd_nonlin_gen_jacobg = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, ya[n].
    utils._EngineFloat64ArrayType.c_type, # Input, yb[n].
    utils._EngineFloat64ArrayType.c_type, # Output, aj[n, n].
    utils._EngineFloat64ArrayType.c_type, # Output, bj[n, n].
    utils._BYREF_INT, # Input, n.
)
bvp_fd_nonlin_gen_jaceps = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[n].
    utils._BYREF_INT, # Input, n.
)
bvp_fd_nonlin_gen_jacgep = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, ya[n].
    utils._EngineFloat64ArrayType.c_type, # Input, yb[n].
    utils._EngineFloat64ArrayType.c_type, # Output, bcep[n].
    utils._BYREF_INT, # Input, n.
)
bvp_fd_nonlin_gen = utils._EngineState._get_symbol('d02raf')
bvp_fd_nonlin_gen.restype = None
bvp_fd_nonlin_gen.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, mnp.
    utils._BYREF_INT, # Input/Output, np.
    utils._BYREF_INT, # Input, numbeg.
    utils._BYREF_INT, # Input, nummix.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, init.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[mnp].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[ldy, mnp].
    utils._BYREF_INT, # Input, ldy.
    utils._EngineFloat64ArrayType.c_type, # Output, abt[n].
    bvp_fd_nonlin_gen_fcn,
    bvp_fd_nonlin_gen_g,
    utils._BYREF_INT, # Input, ijac.
    bvp_fd_nonlin_gen_jacobf,
    bvp_fd_nonlin_gen_jacobg,
    utils._BYREF_FLOAT64, # Input/Output, deleps.
    bvp_fd_nonlin_gen_jaceps,
    bvp_fd_nonlin_gen_jacgep,
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_shoot_genpar_algeq_range = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Output, x[npoint].
    utils._BYREF_INT, # Input, npoint.
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
)
bvp_shoot_genpar_algeq_bc = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Output, g1[n].
    utils._EngineFloat64ArrayType.c_type, # Output, g2[n].
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
)
bvp_shoot_genpar_algeq_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[n].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, i.
)
bvp_shoot_genpar_algeq_eqn = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Output, e[q].
    utils._BYREF_INT, # Input, q.
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
)
bvp_shoot_genpar_algeq_constr = utils._EngineState._sys_functype(
    utils._EngineLogicalScalarType.c_type,
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
)
bvp_shoot_genpar_algeq_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, istate.
    utils._BYREF_INT, # Input, iflag.
    utils._BYREF_INT, # Input, ifail1.
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, f[m].
    utils._BYREF_FLOAT64, # Input, pnorm.
    utils._BYREF_FLOAT64, # Input, pnorm1.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, d[m].
)
bvp_shoot_genpar_algeq_prsol = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input/Output, z.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._BYREF_INT, # Input, n.
)
bvp_shoot_genpar_algeq = utils._EngineState._get_symbol('d02saf')
bvp_shoot_genpar_algeq.restype = None
bvp_shoot_genpar_algeq.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input/Output, p[m].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, n1.
    utils._EngineFloat64ArrayType.c_type, # Input, pe[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, pf[m].
    utils._EngineFloat64ArrayType.c_type, # Input, e[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, dp[m].
    utils._BYREF_INT, # Input, npoint.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, swp[ldswp, 6].
    utils._BYREF_INT, # Input, ldswp.
    utils._BYREF_INT, # Input, icount.
    bvp_shoot_genpar_algeq_range,
    bvp_shoot_genpar_algeq_bc,
    bvp_shoot_genpar_algeq_fcn,
    bvp_shoot_genpar_algeq_eqn,
    bvp_shoot_genpar_algeq_constr,
    utils._BYREF_FLOAT64, # Input, ymax.
    bvp_shoot_genpar_algeq_monit,
    bvp_shoot_genpar_algeq_prsol,
    utils._EngineFloat64ArrayType.c_type, # Output, w[ldw, sdw].
    utils._BYREF_INT, # Input, ldw.
    utils._BYREF_INT, # Input, sdw.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_shoot_genpar_algeq_dummy_monit = utils._EngineState._get_symbol('d02sas')
bvp_shoot_genpar_algeq_dummy_monit.restype = None
bvp_shoot_genpar_algeq_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, istate.
    utils._BYREF_INT, # Input, iflag.
    utils._BYREF_INT, # Input, ifail1.
    utils._EngineFloat64ArrayType.c_type, # Input, p[m].
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, f[m].
    utils._BYREF_FLOAT64, # Input, pnorm.
    utils._BYREF_FLOAT64, # Input, pnorm1.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Input, d[m].
)

bvp_coll_nth_comp_coeff = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_INT, # Input, i.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[ia, ia1].
    utils._BYREF_INT, # Input, ia.
    utils._BYREF_INT, # Input, ia1.
    utils._BYREF_FLOAT64, # Input/Output, rhs.
)
bvp_coll_nth_comp_bdyc = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Output, x.
    utils._BYREF_INT, # Input, i.
    utils._BYREF_INT, # Input, j.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[ia, ia1].
    utils._BYREF_INT, # Input, ia.
    utils._BYREF_INT, # Input, ia1.
    utils._BYREF_FLOAT64, # Input/Output, rhs.
)
bvp_coll_nth_comp = utils._EngineState._get_symbol('d02tgf')
bvp_coll_nth_comp.restype = None
bvp_coll_nth_comp.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, m[n].
    utils._EngineIntArrayType.c_type, # Input, l[n].
    utils._BYREF_FLOAT64, # Input, x0.
    utils._BYREF_FLOAT64, # Input, x1.
    utils._BYREF_INT, # Input, k1.
    utils._BYREF_INT, # Input, kp.
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, n].
    utils._BYREF_INT, # Input, ldc.
    bvp_coll_nth_comp_coeff,
    bvp_coll_nth_comp_bdyc,
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Workspace, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_coll_nlin_solve_ffun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq, 0:*].
    utils._BYREF_INT, # Input, neq.
    utils._EngineIntArrayType.c_type, # Input, m[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, f[neq].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bvp_coll_nlin_solve_fjac = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Input, y[neq, 0:*].
    utils._BYREF_INT, # Input, neq.
    utils._EngineIntArrayType.c_type, # Input, m[neq].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, dfdy[neq, neq, 0:*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bvp_coll_nlin_solve_gafun = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Input, ya[neq, 0:*].
    utils._BYREF_INT, # Input, neq.
    utils._EngineIntArrayType.c_type, # Input, m[neq].
    utils._BYREF_INT, # Input, nlbc.
    utils._EngineFloat64ArrayType.c_type, # Output, ga[nlbc].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bvp_coll_nlin_solve_gbfun = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Input, yb[neq, 0:*].
    utils._BYREF_INT, # Input, neq.
    utils._EngineIntArrayType.c_type, # Input, m[neq].
    utils._BYREF_INT, # Input, nrbc.
    utils._EngineFloat64ArrayType.c_type, # Output, gb[nrbc].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bvp_coll_nlin_solve_gajac = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Input, ya[neq, 0:*].
    utils._BYREF_INT, # Input, neq.
    utils._EngineIntArrayType.c_type, # Input, m[neq].
    utils._BYREF_INT, # Input, nlbc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, dgady[nlbc, neq, 0:*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bvp_coll_nlin_solve_gbjac = utils._EngineState._sys_functype(
    None,
    utils._EngineFloat64ArrayType.c_type, # Input, yb[neq, 0:*].
    utils._BYREF_INT, # Input, neq.
    utils._EngineIntArrayType.c_type, # Input, m[neq].
    utils._BYREF_INT, # Input, nrbc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, dgbdy[nrbc, neq, 0:*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bvp_coll_nlin_solve_guess = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_INT, # Input, neq.
    utils._EngineIntArrayType.c_type, # Input, m[neq].
    utils._EngineFloat64ArrayType.c_type, # Output, y[neq, 0:*].
    utils._EngineFloat64ArrayType.c_type, # Output, dym[neq].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bvp_coll_nlin_solve = utils._EngineState._get_symbol('d02tlf')
bvp_coll_nlin_solve.restype = None
bvp_coll_nlin_solve.argtypes = (
    bvp_coll_nlin_solve_ffun,
    bvp_coll_nlin_solve_fjac,
    bvp_coll_nlin_solve_gafun,
    bvp_coll_nlin_solve_gbfun,
    bvp_coll_nlin_solve_gajac,
    bvp_coll_nlin_solve_gbjac,
    bvp_coll_nlin_solve_guess,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rcomm[*].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_coll_nlin_setup = utils._EngineState._get_symbol('d02tvf')
bvp_coll_nlin_setup.restype = None
bvp_coll_nlin_setup.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._EngineIntArrayType.c_type, # Input, m[neq].
    utils._BYREF_INT, # Input, nlbc.
    utils._BYREF_INT, # Input, nrbc.
    utils._BYREF_INT, # Input, ncol.
    utils._EngineFloat64ArrayType.c_type, # Input, tols[neq].
    utils._BYREF_INT, # Input, mxmesh.
    utils._BYREF_INT, # Input, nmesh.
    utils._EngineFloat64ArrayType.c_type, # Input, mesh[mxmesh].
    utils._EngineIntArrayType.c_type, # Input, ipmesh[mxmesh].
    utils._EngineFloat64ArrayType.c_type, # Output, rcomm[lrcomm].
    utils._BYREF_INT, # Input, lrcomm.
    utils._EngineIntArrayType.c_type, # Output, icomm[licomm].
    utils._BYREF_INT, # Input, licomm.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_coll_nlin_contin = utils._EngineState._get_symbol('d02txf')
bvp_coll_nlin_contin.restype = None
bvp_coll_nlin_contin.argtypes = (
    utils._BYREF_INT, # Input, mxmesh.
    utils._BYREF_INT, # Input, nmesh.
    utils._EngineFloat64ArrayType.c_type, # Input, mesh[mxmesh].
    utils._EngineIntArrayType.c_type, # Input, ipmesh[mxmesh].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rcomm[*].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_coll_nlin_interp = utils._EngineState._get_symbol('d02tyf')
bvp_coll_nlin_interp.restype = None
bvp_coll_nlin_interp.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineFloat64ArrayType.c_type, # Output, y[neq, mmax].
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_INT, # Input, mmax.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rcomm[*].
    utils._EngineIntArrayType.c_type, # Input, icomm[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_coll_nlin_diag = utils._EngineState._get_symbol('d02tzf')
bvp_coll_nlin_diag.restype = None
bvp_coll_nlin_diag.argtypes = (
    utils._BYREF_INT, # Input, mxmesh.
    utils._BYREF_INT, # Output, nmesh.
    utils._EngineFloat64ArrayType.c_type, # Output, mesh[mxmesh].
    utils._EngineIntArrayType.c_type, # Output, ipmesh[mxmesh].
    utils._BYREF_FLOAT64, # Output, ermx.
    utils._BYREF_INT, # Output, iermx.
    utils._BYREF_INT, # Output, ijermx.
    utils._EngineFloat64ArrayType.c_type, # Input, rcomm[*].
    utils._EngineIntArrayType.c_type, # Input, icomm[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_ps_lin_coeffs = utils._EngineState._get_symbol('d02uaf')
bvp_ps_lin_coeffs.restype = None
bvp_ps_lin_coeffs.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, f[n+1].
    utils._EngineFloat64ArrayType.c_type, # Output, c[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_ps_lin_cgl_vals = utils._EngineState._get_symbol('d02ubf')
bvp_ps_lin_cgl_vals.restype = None
bvp_ps_lin_cgl_vals.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_INT, # Input, q.
    utils._EngineFloat64ArrayType.c_type, # Input, c[n+1].
    utils._EngineFloat64ArrayType.c_type, # Output, f[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_ps_lin_cgl_grid = utils._EngineState._get_symbol('d02ucf')
bvp_ps_lin_cgl_grid.restype = None
bvp_ps_lin_cgl_grid.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_ps_lin_cgl_deriv = utils._EngineState._get_symbol('d02udf')
bvp_ps_lin_cgl_deriv.restype = None
bvp_ps_lin_cgl_deriv.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, f[n+1].
    utils._EngineFloat64ArrayType.c_type, # Output, fd[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_ps_lin_solve = utils._EngineState._get_symbol('d02uef')
bvp_ps_lin_solve.restype = None
bvp_ps_lin_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, c[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bmat[m, m+1].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input, bvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, f[m+1].
    utils._EngineFloat64ArrayType.c_type, # Output, uc[n+1, m+1].
    utils._BYREF_FLOAT64, # Output, resid.
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_ps_lin_grid_vals = utils._EngineState._get_symbol('d02uwf')
bvp_ps_lin_grid_vals.restype = None
bvp_ps_lin_grid_vals.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nip.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input, f[n+1].
    utils._EngineFloat64ArrayType.c_type, # Output, xip[nip].
    utils._EngineFloat64ArrayType.c_type, # Output, fip[nip].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_ps_lin_quad_weights = utils._EngineState._get_symbol('d02uyf')
bvp_ps_lin_quad_weights.restype = None
bvp_ps_lin_quad_weights.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, w[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
)

bvp_ps_lin_cheb_eval = utils._EngineState._get_symbol('d02uzf')
bvp_ps_lin_cheb_eval.restype = None
bvp_ps_lin_cheb_eval.argtypes = (
    utils._BYREF_INT, # Input, k.
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Output, t.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_nat_interp = utils._EngineState._get_symbol('d02xjf')
ivp_stiff_nat_interp.restype = None
ivp_stiff_nat_interp.argtypes = (
    utils._BYREF_FLOAT64, # Input, xsol.
    utils._EngineFloat64ArrayType.c_type, # Output, sol[m].
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_INT, # Input, sdysav.
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_INT, # Input, nqu.
    utils._BYREF_FLOAT64, # Input, hu.
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_c1_interp = utils._EngineState._get_symbol('d02xkf')
ivp_stiff_c1_interp.restype = None
ivp_stiff_c1_interp.argtypes = (
    utils._BYREF_FLOAT64, # Input, xsol.
    utils._EngineFloat64ArrayType.c_type, # Output, sol[m].
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, ysav[ldysav, sdysav].
    utils._BYREF_INT, # Input, ldysav.
    utils._BYREF_INT, # Input, sdysav.
    utils._EngineFloat64ArrayType.c_type, # Input, acor[neq].
    utils._BYREF_INT, # Input, neq.
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_INT, # Input, nqu.
    utils._BYREF_FLOAT64, # Input, hu.
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_INT, # Input/Output, ifail.
)

ivp_stiff_errest = utils._EngineState._get_symbol('d02zaf')
ivp_stiff_errest.restype = utils._EngineFloat64ScalarType.c_type
ivp_stiff_errest.argtypes = (
    utils._BYREF_INT, # Input, neq.
    utils._EngineFloat64ArrayType.c_type, # Input, v[neq].
    utils._EngineFloat64ArrayType.c_type, # Input, w[neq].
    utils._BYREF_INT, # Input/Output, ifail.
)
