#!/usr/bin/env python
"``naginterface.library.info.impl_details`` Python Example."

# NAG Copyright 2017-2018.

def main():
    """
    Example for :func:`naginterfaces.library.info.impl_details`.

    Details about the underlying implementation of the NAG Library Engine.

    >>> main()
    naginterfaces.library.info.impl_details Python Example Results.
    dict of details about the underlying implementation of the
    NAG Library Engine:
    {'build_id': ...,
     'compilers': {'C': {'flags': ...,
                         'title': ...,
                   'C++': {'flags': ...,
                           'title': ...,
                   'Fortran': {'flags': ...,
                               'title': ...}},
     'hardware': ...,
     'integer_bits': ...,
     'mark': ...,
     'os': ...,
     'precision': ...,
     'product_code': ...,
     'title': ...,
     'vendor_lib': ...}
   """

    import pprint

    from naginterfaces.library import info

    print('naginterfaces.library.info.impl_details Python Example Results.')
    print('dict of details about the underlying implementation of the')
    print('NAG Library Engine:')

    pprint.pprint(info.impl_details())

if __name__ == '__main__':
    import doctest
    import sys
    main()
    sys.exit(
        doctest.testmod(
            None, verbose=False, report=False,
            optionflags=doctest.ELLIPSIS | doctest.REPORT_NDIFF,
        ).failed
    )
